/*
 * Ben NanoNote stage 2 payload test.
 *
 * Copyright (C) Wolfgang Spraul <wolfgang@sharism.cc>
 * Copyright (C) 2015 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifdef CONFIG_CPU_JZ4730_MINIPC
#include "board-minipc.h"
#else
#include "board-nanonote.h"
#endif

#include "lcd.h"

void c_main(void)
{
	/* Relocate object locations. */

        volatile unsigned int start_addr, got_start, got_end, addr, offset;
	volatile int started;

        /* get absolute start address  */
        __asm__ __volatile__(
                "move %0, $20\n\t"
                : "=r"(start_addr)
                :
                );

        /* get related GOT address  */
        __asm__ __volatile__(
                "la $4, _GLOBAL_OFFSET_TABLE_\n\t"
                "move %0, $4\n\t"
                "la $5, _got_end\n\t"
                "move %1, $5\n\t"
                : "=r"(got_start),"=r"(got_end)
                :
                );

        /* calculate offset and correct GOT*/
        offset = start_addr - 0x80000000;
        got_start += offset;
        got_end  += offset;

        for ( addr = got_start + 8; addr < got_end; addr += 4 )
                *((volatile unsigned int *)(addr)) += offset; // add offset to correct all GOT

	/* The actual work. */

	started = is_started();
	if (!started) {
		gpio_init2();
		cpm_init();
		rtc_init();
		timer_init();
	}
	lcd_init();
	while (1);
}
